package com.maroontress.coverture.gcno;

import com.maroontress.coverture.CorruptedFileException;
import com.maroontress.coverture.Parser;
import com.maroontress.coverture.Tag;
import com.maroontress.coverture.UnexpectedTagException;
import java.io.IOException;
import java.nio.ByteBuffer;

/**
   ؿΥ쥳ɤǤ

   announce_function: header int32:ident int32:checksum string:name
                      string:source int32:lineno
*/
public final class AnnounceFunctionRecord {

    /** ̻ҤǤ */
    private int id;

    /** ؿΥåǤ */
    private int checksum;

    /** ؿ̾Ǥ */
    private String functionName;

    /** ɤΥե̾Ǥ */
    private String sourceFile;

    /** ؿи륽ɤιԿǤ */
    private int lineNumber;

    /**
       ХȥХåեANNOUNCE_FUNCTION쥳ɤϤ
       ANNOUNCE_FUNCTION쥳ɤޤХȥХåեΰ֤
       ANNOUNCE_FUNCTION쥳ɤƬΰ֤ǤʤФʤޤ
       ϡХȥХåեΰ֤ANNOUNCE_FUNCTION쥳ɤμ
       ΰ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException
       @throws UnexpectedTagException
    */
    public AnnounceFunctionRecord(final ByteBuffer bb)
	throws IOException, UnexpectedTagException {
	int tag = bb.getInt();
	int length = bb.getInt();
	int next = bb.position() + 4 * length;

	if (tag != Tag.FUNCTION) {
	    String m = String.format("unexpected tag: 0x%x", tag);
	    throw new UnexpectedTagException(m);
	}
	id = bb.getInt();
	checksum = bb.getInt();
	functionName = Parser.getString(bb);
	sourceFile = Parser.getString(bb);
	lineNumber = bb.getInt();
	bb.position(next);
    }

    /**
       ̻Ҥޤ

       @return ̻
    */
    public int getId() {
	return id;
    }

    /**
       ؿΥåޤ

       @return ؿΥå
    */
    public int getChecksum() {
	return checksum;
    }

    /**
       ؿ̾ޤ

       @return ؿ̾
    */
    public String getFunctionName() {
	return functionName;
    }

    /**
       ɤΥե̾ޤ

       @return ɤΥե̾
    */
    public String getSourceFile() {
	return sourceFile;
    }

    /**
       ؿи륽ɤιԿޤ

       @return ؿи륽ɤιԿ
    */
    public int getLineNumber() {
	return lineNumber;
    }
}
